#
# spec file for package intel-e1000e (Version 3.4.0.2)
#
# Copyright (c) 2018 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://support.novell.com
#



Name:           intel-e1000e
Summary:        Intel(R) PRO/1000 Gigabit Ethernet driver
Version:        3.4.0.2
Release:        100R.4.1
Source0:        e1000e-%{version}.tar.bz2
Source1:        preamble
License:        GPL-2.0
Group:          System/Kernel
BuildRequires:  %kernel_module_package_buildreqs
BuildRequires:  pciutils-ids
Requires:       pciutils-ids
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%kernel_module_package -p %_sourcedir/preamble

%description
This driver supports Intel(R) PRO/1000 gigabit ethernet family of
adapters.  For more information on how to identify your adapter, go
to the Adapter & Driver ID Guide at:

<http://support.intel.com/support/network/adapter/pro100/21397.htm>

For general information and support, go to the Intel support
website at: <http://support.intel.com>

More specific information on configuring the driver is in
/usr/share/doc/packages/intel-e1000e/README

The driver is delivered in multiple binary packages.
The 'intel-e1000e' base package provides the common driver documentation, and
updates to the pciutils pci-ids database. The 'intel-e1000e-kmp-<flavor>'
sub-packages provide the kernel modules for the specific kernel flavors.

%package KMP  
  
Summary:     Intel(R) PRO/1000 Gigabit Ethernet driver
Group:       System/Kernel  

%description KMP
This driver supports Intel(R) PRO/1000 gigabit ethernet family of
adapters.  For more information on how to identify your adapter, go
to the Adapter & Driver ID Guide at:

<http://support.intel.com/support/network/adapter/pro100/21397.htm>

For general information and support, go to the Intel support
website at: <http://support.intel.com>

More specific information on configuring the driver is in
/usr/share/doc/packages/intel-e1000e/README

This sub-package provides the kernel module(s) for the specific kernel flavor as
indicated by the 'intel-e1000e-kmp-<flavor>' package name. Driver documentation and
updates to the pciutils pci-ids database are provided by the 'intel-e1000e' base
package.

%prep
%setup -n e1000e-%{version}
set -- *
mv src source
echo "e1000e.ko external" > source/Module.supported
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
%bcond_with retpoline
%if %{with retpoline}
export KCFLAGS='-mindirect-branch=thunk-inline -mindirect-branch-register'
find source -name *.c -print0 | xargs -0 sed -i '/MODULE_LICENSE(/a MODULE_INFO(retpoline, "Y");'
%endif
for flavor in %flavors_to_build; do
    rm -rf obj/$flavor
    cp -r source obj/$flavor
    make -C %{kernel_source $flavor} modules M=$PWD/obj/$flavor
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%{kernel_module_package_moddir %name}
for flavor in %flavors_to_build; do
    make -C %{kernel_source $flavor} modules_install M=$PWD/obj/$flavor
done

mkdir -p $RPM_BUILD_ROOT/usr/share/pci.ids.d
install -D -m 644 pci.updates $RPM_BUILD_ROOT/usr/share/pci.ids.d/pci.ids.intel-e1000e-%{version}

mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man7
install -m 644 -D e1000e.7 $RPM_BUILD_ROOT/%{_mandir}/man7
gzip -9nf $RPM_BUILD_ROOT/%{_mandir}/man?/*.?

chmod -x COPYING README

%clean
rm -rf %{buildroot}

%files 
%defattr(-,root,root)
%{_mandir}/man7/e1000e.7.gz
/usr/share/pci.ids.d/pci.ids.intel-e1000e-%{version}
%doc COPYING 
%doc README

%post 
if [ -x /usr/bin/merge-pciids -a -x /usr/bin/perl ]; then
  /usr/bin/merge-pciids
else
  echo "ERROR: merge-pciids or perl not found"
fi

%postun
if [ -x /usr/bin/merge-pciids -a -x /usr/bin/perl ]; then
  /usr/bin/merge-pciids
else
  echo "ERROR: merge-pciids or perl not found"
fi

%changelog
* Tue May 15 2018 sbahling@suse.com
- Patch in retpoline flag for all retoline builds.
* Wed May  2 2018 sbahling@suse.com
- Add build condition to build retpoline as inline thunk
* Tue Jan 23 2018 sbahling@suse.com
- Initial SUSE PLDP build of automatic source pullfrom e1000.sf.net
  Pulled from https://netcologne.dl.sourceforge.net/project/e1000//e1000e%%20stable/3.4.0.2/e1000e-3.4.0.2.tar.gz
- Release README:
  Changelog for 3.4.0.2
  * Fix Overflow Buffer.
  * Initial support for the following devices:
  Ethernet Connection (6) I219-LM
  Ethernet Connection (6) I219-V
  Ethernet Connection (7) I219-LM
  Ethernet Connection (7) I219-V
  * Minor bug fixes.
  * Cosmetic changes.
